
// automatically generated by m4 from headers in proto subdir


#ifndef __STDLIB_H__
#define __STDLIB_H__

#include <stddef.h>
#include <stdint.h>

// DATA STRUCTURES

#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned int  size_t;
#endif

#ifndef _WCHAR_T
#define _WCHAR_T
typedef unsigned char wchar_t;
#endif

#ifndef _FLOAT_T
#define _FLOAT_T

   #ifdef __CLANG
   
   typedef float float_t;
   
   #endif

   #ifdef __SDCC
   
   typedef float float_t;
   
   #endif
   
   #ifdef __SCCZ80
   
   typedef double float_t;
   
   #endif
   
#endif

#ifndef _DOUBLE_T
#define _DOUBLE_T

   #ifdef __CLANG
   
   typedef float double_t;
   
   #endif

   #ifdef __SDCC
   
   typedef float double_t;
   
   #endif
   
   #ifdef __SCCZ80
   
   typedef double double_t;
   
   #endif
   
#endif

typedef struct
{

   int rem;
   int quot;

} div_t;

typedef struct
{

   unsigned int rem;
   unsigned int quot;

} divu_t;

typedef struct
{

   long quot;
   long rem;

} ldiv_t;

typedef struct
{

   unsigned long quot;
   unsigned long rem;

} ldivu_t;

#ifdef __CLANG

   typedef struct
   {
      long long rem;
      long long quot;
   
   } lldiv_t;

   typedef struct
   {
      unsigned long long rem;
      unsigned long long quot;

   } lldivu_t;

#endif

#ifdef __SDCC

   typedef struct
   {
      long long rem;
      long long quot;
   
   } lldiv_t;

   typedef struct
   {
      unsigned long long rem;
      unsigned long long quot;

   } lldivu_t;

#endif

#ifndef NULL
#define NULL            ((void*)(0))
#endif

#define EXIT_FAILURE    0
#define EXIT_SUCCESS    1

#define RAND_MAX        32767

#define MB_CUR_MAX      1

#define FTOA_FLAG_PLUS  0x40
#define FTOA_FLAG_SPACE 0x20
#define FTOA_FLAG_HASH  0x10

#define DTOA_FLAG_PLUS  0x40
#define DTOA_FLAG_SPACE 0x20
#define DTOA_FLAG_HASH  0x10

// FUNCTIONS

extern void __LIB__ _div_(div_t *d,int numer,int denom) __smallc;
extern void __LIB__ _div__callee(div_t *d,int numer,int denom) __smallc __z88dk_callee;
#define _div_(a,b,c) _div__callee(a,b,c)


extern void __LIB__ _divu_(divu_t *d,unsigned int numer,unsigned int denom) __smallc;
extern void __LIB__ _divu__callee(divu_t *d,unsigned int numer,unsigned int denom) __smallc __z88dk_callee;
#define _divu_(a,b,c) _divu__callee(a,b,c)


extern void __LIB__ _ldiv_(ldiv_t *ld,long numer,long denom) __smallc;
extern void __LIB__ _ldiv__callee(ldiv_t *ld,long numer,long denom) __smallc __z88dk_callee;
#define _ldiv_(a,b,c) _ldiv__callee(a,b,c)


extern void __LIB__ _ldivu_(ldivu_t *ld,unsigned long numer,unsigned long denom) __smallc;
extern void __LIB__ _ldivu__callee(ldivu_t *ld,unsigned long numer,unsigned long denom) __smallc __z88dk_callee;
#define _ldivu_(a,b,c) _ldivu__callee(a,b,c)


extern void __LIB__ _insertion_sort_(void *base,size_t nmemb,size_t size,void *compar) __smallc;
extern void __LIB__ _insertion_sort__callee(void *base,size_t nmemb,size_t size,void *compar) __smallc __z88dk_callee;
#define _insertion_sort_(a,b,c,d) _insertion_sort__callee(a,b,c,d)


extern void __LIB__ _quicksort_(void *base,size_t nmemb,size_t size,void *compar) __smallc;
extern void __LIB__ _quicksort__callee(void *base,size_t nmemb,size_t size,void *compar) __smallc __z88dk_callee;
#define _quicksort_(a,b,c,d) _quicksort__callee(a,b,c,d)


extern void __LIB__ _shellsort_(void *base,size_t nmemb,size_t size,void *compar) __smallc;
extern void __LIB__ _shellsort__callee(void *base,size_t nmemb,size_t size,void *compar) __smallc __z88dk_callee;
#define _shellsort_(a,b,c,d) _shellsort__callee(a,b,c,d)


extern uint16_t __LIB__ _random_uniform_cmwc_8_(void *seed) __smallc __z88dk_fastcall;


extern uint32_t __LIB__ _random_uniform_xor_32_(uint32_t *seed) __smallc __z88dk_fastcall;


extern uint16_t __LIB__ _random_uniform_xor_8_(uint32_t *seed) __smallc __z88dk_fastcall;


extern int __LIB__ _strtoi_(char *nptr,char **endptr,int base) __smallc;
extern int __LIB__ _strtoi__callee(char *nptr,char **endptr,int base) __smallc __z88dk_callee;
#define _strtoi_(a,b,c) _strtoi__callee(a,b,c)


extern uint16_t __LIB__ _strtou_(char *nptr,char **endptr,int base) __smallc;
extern uint16_t __LIB__ _strtou__callee(char *nptr,char **endptr,int base) __smallc __z88dk_callee;
#define _strtou_(a,b,c) _strtou__callee(a,b,c)


extern void __LIB__ abort(void) __smallc;


extern int __LIB__ abs(int j) __smallc __z88dk_fastcall;


extern int __LIB__ at_quick_exit(void *func) __smallc __z88dk_fastcall;


extern int __LIB__ atexit(void *func) __smallc __z88dk_fastcall;


extern double_t __LIB__ atof(char *nptr) __smallc __z88dk_fastcall;


extern int __LIB__ atoi(char *buf) __smallc __z88dk_fastcall;


extern long __LIB__ atol(char *buf) __smallc __z88dk_fastcall;


extern void __LIB__ *bsearch(void *key,void *base,size_t nmemb,size_t size,void *compar) __smallc;
extern void __LIB__ *bsearch_callee(void *key,void *base,size_t nmemb,size_t size,void *compar) __smallc __z88dk_callee;
#define bsearch(a,b,c,d,e) bsearch_callee(a,b,c,d,e)


extern size_t __LIB__ dtoa(double_t x,void *buf,uint16_t prec,uint16_t flags) __smallc;
extern size_t __LIB__ dtoa_callee(double_t x,void *buf,uint16_t prec,uint16_t flags) __smallc __z88dk_callee;
#define dtoa(a,b,c,d) dtoa_callee(a,b,c,d)


extern size_t __LIB__ dtoe(double_t x,void *buf,uint16_t prec,uint16_t flags) __smallc;
extern size_t __LIB__ dtoe_callee(double_t x,void *buf,uint16_t prec,uint16_t flags) __smallc __z88dk_callee;
#define dtoe(a,b,c,d) dtoe_callee(a,b,c,d)


extern size_t __LIB__ dtog(double_t x,void *buf,uint16_t prec,uint16_t flags) __smallc;
extern size_t __LIB__ dtog_callee(double_t x,void *buf,uint16_t prec,uint16_t flags) __smallc __z88dk_callee;
#define dtog(a,b,c,d) dtog_callee(a,b,c,d)


extern size_t __LIB__ dtoh(double_t x,void *buf,uint16_t prec,uint16_t flags) __smallc;
extern size_t __LIB__ dtoh_callee(double_t x,void *buf,uint16_t prec,uint16_t flags) __smallc __z88dk_callee;
#define dtoh(a,b,c,d) dtoh_callee(a,b,c,d)


extern void __LIB__ exit(int status) __smallc __z88dk_fastcall;


extern size_t __LIB__ ftoa(float_t x,void *buf,uint16_t prec,uint16_t flags) __smallc;
extern size_t __LIB__ ftoa_callee(float_t x,void *buf,uint16_t prec,uint16_t flags) __smallc __z88dk_callee;
#define ftoa(a,b,c,d) ftoa_callee(a,b,c,d)


extern size_t __LIB__ ftoe(float_t x,void *buf,uint16_t prec,uint16_t flags) __smallc;
extern size_t __LIB__ ftoe_callee(float_t x,void *buf,uint16_t prec,uint16_t flags) __smallc __z88dk_callee;
#define ftoe(a,b,c,d) ftoe_callee(a,b,c,d)


extern size_t __LIB__ ftog(float_t x,void *buf,uint16_t prec,uint16_t flags) __smallc;
extern size_t __LIB__ ftog_callee(float_t x,void *buf,uint16_t prec,uint16_t flags) __smallc __z88dk_callee;
#define ftog(a,b,c,d) ftog_callee(a,b,c,d)


extern size_t __LIB__ ftoh(float_t x,void *buf,uint16_t prec,uint16_t flags) __smallc;
extern size_t __LIB__ ftoh_callee(float_t x,void *buf,uint16_t prec,uint16_t flags) __smallc __z88dk_callee;
#define ftoh(a,b,c,d) ftoh_callee(a,b,c,d)


extern char __LIB__ *itoa(int num,char *buf,int radix) __smallc;
extern char __LIB__ *itoa_callee(int num,char *buf,int radix) __smallc __z88dk_callee;
#define itoa(a,b,c) itoa_callee(a,b,c)


extern long __LIB__ labs(long j) __smallc __z88dk_fastcall;


extern char __LIB__ *ltoa(long num,char *buf,int radix) __smallc;
extern char __LIB__ *ltoa_callee(long num,char *buf,int radix) __smallc __z88dk_callee;
#define ltoa(a,b,c) ltoa_callee(a,b,c)


extern void __LIB__ qsort(void *base,size_t nmemb,size_t size,void *compar) __smallc;
extern void __LIB__ qsort_callee(void *base,size_t nmemb,size_t size,void *compar) __smallc __z88dk_callee;
#define qsort(a,b,c,d) qsort_callee(a,b,c,d)


extern void __LIB__ quick_exit(int status) __smallc __z88dk_fastcall;


extern int __LIB__ rand(void) __smallc;


extern void __LIB__ srand(uint16_t seed) __smallc __z88dk_fastcall;


extern double_t __LIB__ strtod(char *nptr,char **endptr) __smallc;
extern double_t __LIB__ strtod_callee(char *nptr,char **endptr) __smallc __z88dk_callee;
#define strtod(a,b) strtod_callee(a,b)


extern float_t __LIB__ strtof(char *nptr,char **endptr) __smallc;
extern float_t __LIB__ strtof_callee(char *nptr,char **endptr) __smallc __z88dk_callee;
#define strtof(a,b) strtof_callee(a,b)


extern long __LIB__ strtol(char *nptr,char **endptr,int base) __smallc;
extern long __LIB__ strtol_callee(char *nptr,char **endptr,int base) __smallc __z88dk_callee;
#define strtol(a,b,c) strtol_callee(a,b,c)


extern uint32_t __LIB__ strtoul(char *nptr,char **endptr,int base) __smallc;
extern uint32_t __LIB__ strtoul_callee(char *nptr,char **endptr,int base) __smallc __z88dk_callee;
#define strtoul(a,b,c) strtoul_callee(a,b,c)


extern int __LIB__ system(char *s) __smallc __z88dk_fastcall;


extern char __LIB__ *ultoa(uint32_t num,char *buf,int radix) __smallc;
extern char __LIB__ *ultoa_callee(uint32_t num,char *buf,int radix) __smallc __z88dk_callee;
#define ultoa(a,b,c) ultoa_callee(a,b,c)


extern char __LIB__ *utoa(uint16_t num,char *buf,int radix) __smallc;
extern char __LIB__ *utoa_callee(uint16_t num,char *buf,int radix) __smallc __z88dk_callee;
#define utoa(a,b,c) utoa_callee(a,b,c)



#ifndef __ALLOC_MALLOC_H__

extern void __LIB__ *aligned_alloc(size_t alignment,size_t size) __smallc;
extern void __LIB__ *aligned_alloc_callee(size_t alignment,size_t size) __smallc __z88dk_callee;
#define aligned_alloc(a,b) aligned_alloc_callee(a,b)


extern void __LIB__ *calloc(size_t nmemb,size_t size) __smallc;
extern void __LIB__ *calloc_callee(size_t nmemb,size_t size) __smallc __z88dk_callee;
#define calloc(a,b) calloc_callee(a,b)


extern void __LIB__ free(void *p) __smallc __z88dk_fastcall;


extern void __LIB__ *malloc(size_t size) __smallc __z88dk_fastcall;


extern void __LIB__ *realloc(void *p,size_t size) __smallc;
extern void __LIB__ *realloc_callee(void *p,size_t size) __smallc __z88dk_callee;
#define realloc(a,b) realloc_callee(a,b)



extern void __LIB__ *aligned_alloc_unlocked(size_t alignment,size_t size) __smallc;
extern void __LIB__ *aligned_alloc_unlocked_callee(size_t alignment,size_t size) __smallc __z88dk_callee;
#define aligned_alloc_unlocked(a,b) aligned_alloc_unlocked_callee(a,b)


extern void __LIB__ *calloc_unlocked(size_t nmemb,size_t size) __smallc;
extern void __LIB__ *calloc_unlocked_callee(size_t nmemb,size_t size) __smallc __z88dk_callee;
#define calloc_unlocked(a,b) calloc_unlocked_callee(a,b)


extern void __LIB__ free_unlocked(void *p) __smallc __z88dk_fastcall;


extern void __LIB__ *malloc_unlocked(size_t size) __smallc __z88dk_fastcall;


extern void __LIB__ *realloc_unlocked(void *p,size_t size) __smallc;
extern void __LIB__ *realloc_unlocked_callee(void *p,size_t size) __smallc __z88dk_callee;
#define realloc_unlocked(a,b) realloc_unlocked_callee(a,b)



#endif

#ifdef __CLANG

extern long long atoll(char *buf);
extern void _lldiv_(lldiv_t *ld,long long numer,long long denom);
extern void _lldivu_(lldivu_t *ld,unsigned long long numer,unsigned long long denom);
extern long long llabs(long long i);
extern char *lltoa(long long num,char *buf,int radix);
extern long long strtoll(char *nptr,char **endptr,int base);
extern unsigned long long strtoull(char *nptr,char **endptr,int base);
extern char *ulltoa(unsigned long long num,char *buf,int radix);

#endif

#ifdef __SDCC

extern long long atoll(char *buf);
extern long long atoll_callee(char *buf) __z88dk_callee;
#define atoll(a) atoll_callee(a)

extern void __LIB__ _lldiv_(lldiv_t *ld,long long numer,long long denom) __smallc;
extern void __LIB__ _lldiv__callee(lldiv_t *ld,long long numer,long long denom) __smallc __z88dk_callee;
#define _lldiv_(a,b,c) _lldiv__callee(a,b,c)


extern void __LIB__ _lldivu_(lldivu_t *ld,unsigned long long numer,unsigned long long denom) __smallc;
extern void __LIB__ _lldivu__callee(lldivu_t *ld,unsigned long long numer,unsigned long long denom) __smallc __z88dk_callee;
#define _lldivu_(a,b,c) _lldivu__callee(a,b,c)



extern long long llabs(long long i);
extern long long llabs_callee(long long i) __z88dk_callee;
#define llabs(a) llabs_callee(a)
   
extern char __LIB__ *lltoa(long long num,char *buf,int radix) __smallc;
extern char __LIB__ *lltoa_callee(long long num,char *buf,int radix) __smallc __z88dk_callee;
#define lltoa(a,b,c) lltoa_callee(a,b,c)


extern long long __LIB__ strtoll(char *nptr,char **endptr,int base) __smallc;
extern long long __LIB__ strtoll_callee(char *nptr,char **endptr,int base) __smallc __z88dk_callee;
#define strtoll(a,b,c) strtoll_callee(a,b,c)


extern unsigned long long __LIB__ strtoull(char *nptr,char **endptr,int base) __smallc;
extern unsigned long long __LIB__ strtoull_callee(char *nptr,char **endptr,int base) __smallc __z88dk_callee;
#define strtoull(a,b,c) strtoull_callee(a,b,c)


extern char __LIB__ *ulltoa(unsigned long long num,char *buf,int radix) __smallc;
extern char __LIB__ *ulltoa_callee(unsigned long long num,char *buf,int radix) __smallc __z88dk_callee;
#define ulltoa(a,b,c) ulltoa_callee(a,b,c)



#endif

#ifdef __SCCZ80

extern long long atoll(char *buf);
extern long long atoll_callee(char *buf) __z88dk_callee;
#define atoll(a) atoll_callee(a)

extern long long llabs(long long i);
extern long long llabs_callee(long long i) __z88dk_callee;
#define llabs(a) llabs_callee(a)
   
extern char __LIB__ *lltoa(long long num,char *buf,int radix) __smallc;
extern char __LIB__ *lltoa_callee(long long num,char *buf,int radix) __smallc __z88dk_callee;
#define lltoa(a,b,c) lltoa_callee(a,b,c)


extern long long __LIB__ strtoll(char *nptr,char **endptr,int base) __smallc;
extern long long __LIB__ strtoll_callee(char *nptr,char **endptr,int base) __smallc __z88dk_callee;
#define strtoll(a,b,c) strtoll_callee(a,b,c)


extern unsigned long long __LIB__ strtoull(char *nptr,char **endptr,int base) __smallc;
extern unsigned long long __LIB__ strtoull_callee(char *nptr,char **endptr,int base) __smallc __z88dk_callee;
#define strtoull(a,b,c) strtoull_callee(a,b,c)


extern char __LIB__ *ulltoa(unsigned long long num,char *buf,int radix) __smallc;
extern char __LIB__ *ulltoa_callee(unsigned long long num,char *buf,int radix) __smallc __z88dk_callee;
#define ulltoa(a,b,c) ulltoa_callee(a,b,c)



#endif

#ifdef __ZXNEXT

extern unsigned char __LIB__ mkstemp_ex(char *template) __smallc __z88dk_fastcall;



extern char __LIB__ *getenv(const char *name) __smallc __z88dk_fastcall;


extern char __LIB__ *getenv_ex(const char *filename,const char *name) __smallc;
extern char __LIB__ *getenv_ex_callee(const char *filename,const char *name) __smallc __z88dk_callee;
#define getenv_ex(a,b) getenv_ex_callee(a,b)


extern char __LIB__ *env_getenv(unsigned char handle,const char *name,char *val,unsigned int valsz,void *buf,unsigned int bufsz) __smallc;
extern char __LIB__ *env_getenv_callee(unsigned char handle,const char *name,char *val,unsigned int valsz,void *buf,unsigned int bufsz) __smallc __z88dk_callee;
#define env_getenv(a,b,c,d,e,f) env_getenv_callee(a,b,c,d,e,f)



#endif

#endif
