const char book[] = "THE JUNGLE\n\nby Upton Sinclair\n\n\n(1906)\n\n\n\nChapter 1\n\n"
   "It was four o'clock when the ceremony was over and the carriages began "
   "to arrive. There had been a crowd following all the way, owing to the "
   "exuberance of Marija Berczynskas. The occasion rested heavily upon "
   "Marija's broad shoulders--it was her task to see that all things went in "
   "due form, and after the best home traditions; and, flying wildly "
   "hither and thither, bowling every one out of the way, and scolding and "
   "exhorting all day with her tremendous voice, Marija was too eager to see "
   "that others conformed to the proprieties to consider them herself. She "
   "had left the church last of all, and, desiring to arrive first at the "
   "hall, had issued orders to the coachman to drive faster. When that "
   "personage had developed a will of his own in the matter, Marija had "
   "flung up the window of the carriage, and, leaning out, proceeded to "
   "tell him her opinion of him, first in Lithuanian, which he did not "
   "understand, and then in Polish, which he did. Having the advantage of "
   "her in altitude, the driver had stood his ground and even ventured to "
   "attempt to speak; and the result had been a furious altercation, which, "
   "continuing all the way down Ashland Avenue, had added a new swarm of "
   "urchins to the cortege at each side street for half a mile.\n\n"
   "This was unfortunate, for already there was a throng before the door. "
   "The music had started up, and half a block away you could hear the dull "
   "\"broom, broom\" of a cello, with the squeaking of two fiddles which vied "
   "with each other in intricate and altitudinous gymnastics. Seeing "
   "the throng, Marija abandoned precipitately the debate concerning the "
   "ancestors of her coachman, and, springing from the moving carriage, "
   "plunged in and proceeded to clear a way to the hall. Once within, she "
   "turned and began to push the other way, roaring, meantime, \"Eik! Eik! "
   "Uzdaryk-duris!\" in tones which made the orchestral uproar sound like "
   "fairy music.\n\n"
   "\"Z. Graiczunas, Pasilinksminimams darzas. Vynas. Sznapsas. Wines and "
   "Liquors. Union Headquarters\"--that was the way the signs ran. The "
   "reader, who perhaps has never held much converse in the language of "
   "far-off Lithuania, will be glad of the explanation that the place was "
   "the rear room of a saloon in that part of Chicago known as \"back of the "
   "yards.\" This information is definite and suited to the matter of fact; "
   "but how pitifully inadequate it would have seemed to one who understood "
   "that it was also the supreme hour of ecstasy in the life of one of "
   "God's gentlest creatures, the scene of the wedding feast and the "
   "joy-transfiguration of little Ona Lukoszaite!\n\n"
   "She stood in the doorway, shepherded by Cousin Marija, breathless from "
   "pushing through the crowd, and in her happiness painful to look upon. "
   "There was a light of wonder in her eyes and her lids trembled, and "
   "her otherwise wan little face was flushed. She wore a muslin dress, "
   "conspicuously white, and a stiff little veil coming to her shoulders. "
   "There were five pink paper roses twisted in the veil, and eleven bright "
   "green rose leaves. There were new white cotton gloves upon her hands, "
   "and as she stood staring about her she twisted them together feverishly. "
   "It was almost too much for her--you could see the pain of too great "
   "emotion in her face, and all the tremor of her form. She was so "
   "young--not quite sixteen--and small for her age, a mere child; and she "
   "had just been married--and married to Jurgis,* (*Pronounced Yoorghis) of "
   "all men, to Jurgis Rudkus, he with the white flower in the buttonhole of "
   "his new black suit, he with the mighty shoulders and the giant hands.\n\n"
   "Ona was blue-eyed and fair, while Jurgis had great black eyes with "
   "beetling brows, and thick black hair that curled in waves about his "
   "ears--in short, they were one of those incongruous and impossible "
   "married couples with which Mother Nature so often wills to "
   "confound all prophets, before and after. Jurgis could take up a "
   "two-hundred-and-fifty-pound quarter of beef and carry it into a car "
   "without a stagger, or even a thought; and now he stood in a far corner, "
   "frightened as a hunted animal, and obliged to moisten his lips with "
   "his tongue each time before he could answer the congratulations of his "
   "friends.\n\n"
   "Gradually there was effected a separation between the spectators and "
   "the guests--a separation at least sufficiently complete for working "
   "purposes. There was no time during the festivities which ensued when "
   "there were not groups of onlookers in the doorways and the corners; "
   "and if any one of these onlookers came sufficiently close, or looked "
   "sufficiently hungry, a chair was offered him, and he was invited to the "
   "feast. It was one of the laws of the veselija that no one goes hungry; "
   "and, while a rule made in the forests of Lithuania is hard to apply "
   "in the stockyards district of Chicago, with its quarter of a million "
   "inhabitants, still they did their best, and the children who ran in "
   "from the street, and even the dogs, went out again happier. A charming "
   "informality was one of the characteristics of this celebration. The men "
   "wore their hats, or, if they wished, they took them off, and their coats "
   "with them; they ate when and where they pleased, and moved as often as "
   "they pleased. There were to be speeches and singing, but no one had to "
   "listen who did not care to; if he wished, meantime, to speak or sing "
   "himself, he was perfectly free. The resulting medley of sound distracted "
   "no one, save possibly alone the babies, of which there were present a "
   "number equal to the total possessed by all the guests invited. There was "
   "no other place for the babies to be, and so part of the preparations "
   "for the evening consisted of a collection of cribs and carriages in one "
   "corner. In these the babies slept, three or four together, or wakened "
   "together, as the case might be. Those who were still older, and could "
   "reach the tables, marched about munching contentedly at meat bones and "
   "bologna sausages.\n\n"
   "The room is about thirty feet square, with whitewashed walls, bare save "
   "for a calendar, a picture of a race horse, and a family tree in a gilded "
   "frame. To the right there is a door from the saloon, with a few loafers "
   "in the doorway, and in the corner beyond it a bar, with a presiding "
   "genius clad in soiled white, with waxed black mustaches and a carefully "
   "oiled curl plastered against one side of his forehead. In the opposite "
   "corner are two tables, filling a third of the room and laden with "
   "dishes and cold viands, which a few of the hungrier guests are already "
   "munching. At the head, where sits the bride, is a snow-white cake, with "
   "an Eiffel tower of constructed decoration, with sugar roses and two "
   "angels upon it, and a generous sprinkling of pink and green and yellow "
   "candies. Beyond opens a door into the kitchen, where there is a glimpse "
   "to be had of a range with much steam ascending from it, and many women, "
   "old and young, rushing hither and thither. In the corner to the left are "
   "the three musicians, upon a little platform, toiling heroically to make "
   "some impression upon the hubbub; also the babies, similarly occupied, "
   "and an open window whence the populace imbibes the sights and sounds and "
   "odors.\n\n"
   "Suddenly some of the steam begins to advance, and, peering through it, "
   "you discern Aunt Elizabeth, Ona's stepmother--Teta Elzbieta, as they "
   "call her--bearing aloft a great platter of stewed duck. Behind her is "
   "Kotrina, making her way cautiously, staggering beneath a similar burden; "
   "and half a minute later there appears old Grandmother Majauszkiene, with "
   "a big yellow bowl of smoking potatoes, nearly as big as herself. So, bit "
   "by bit, the feast takes form--there is a ham and a dish of sauerkraut, "
   "boiled rice, macaroni, bologna sausages, great piles of penny buns, "
   "bowls of milk, and foaming pitchers of beer. There is also, not six feet "
   "from your back, the bar, where you may order all you please and do not "
   "have to pay for it. \"Eiksz! Graicziau!\" screams Marija Berczynskas, and "
   "falls to work herself--for there is more upon the stove inside that will "
   "be spoiled if it be not eaten.\n\n"
   "So, with laughter and shouts and endless badinage and merriment, the "
   "guests take their places. The young men, who for the most part have "
   "been huddled near the door, summon their resolution and advance; and the "
   "shrinking Jurgis is poked and scolded by the old folks until he consents "
   "to seat himself at the right hand of the bride. The two bridesmaids, "
   "whose insignia of office are paper wreaths, come next, and after them "
   "the rest of the guests, old and young, boys and girls. The spirit of the "
   "occasion takes hold of the stately bartender, who condescends to a plate "
   "of stewed duck; even the fat policeman--whose duty it will be, later in "
   "the evening, to break up the fights--draws up a chair to the foot of the "
   "table. And the children shout and the babies yell, and every one laughs "
   "and sings and chatters--while above all the deafening clamor Cousin "
   "Marija shouts orders to the musicians.\n\n"
   "The musicians--how shall one begin to describe them? All this time they "
   "have been there, playing in a mad frenzy--all of this scene must be "
   "read, or said, or sung, to music. It is the music which makes it what "
   "it is; it is the music which changes the place from the rear room of "
   "a saloon in back of the yards to a fairy place, a wonderland, a little "
   "corner of the high mansions of the sky.\n\n"
   "The little person who leads this trio is an inspired man. His fiddle "
   "is out of tune, and there is no rosin on his bow, but still he is an "
   "inspired man--the hands of the muses have been laid upon him. He plays "
   "like one possessed by a demon, by a whole horde of demons. You can "
   "feel them in the air round about him, capering frenetically; with their "
   "invisible feet they set the pace, and the hair of the leader of the "
   "orchestra rises on end, and his eyeballs start from their sockets, as he "
   "toils to keep up with them.\n\n"
   "Tamoszius Kuszleika is his name, and he has taught himself to play the "
   "violin by practicing all night, after working all day on the \"killing "
   "beds.\" He is in his shirt sleeves, with a vest figured with faded gold "
   "horseshoes, and a pink-striped shirt, suggestive of peppermint candy. "
   "A pair of military trousers, light blue with a yellow stripe, serve to "
   "give that suggestion of authority proper to the leader of a band. He is "
   "only about five feet high, but even so these trousers are about eight "
   "inches short of the ground. You wonder where he can have gotten them or "
   "rather you would wonder, if the excitement of being in his presence left "
   "you time to think of such things.\n\n"
   "For he is an inspired man. Every inch of him is inspired--you might "
   "almost say inspired separately. He stamps with his feet, he tosses his "
   "head, he sways and swings to and fro; he has a wizened-up little face, "
   "irresistibly comical; and, when he executes a turn or a flourish, his "
   "brows knit and his lips work and his eyelids wink--the very ends of "
   "his necktie bristle out. And every now and then he turns upon his "
   "companions, nodding, signaling, beckoning frantically--with every inch "
   "of him appealing, imploring, in behalf of the muses and their call.\n\n"
   "For they are hardly worthy of Tamoszius, the other two members of "
   "the orchestra. The second violin is a Slovak, a tall, gaunt man with "
   "black-rimmed spectacles and the mute and patient look of an overdriven "
   "mule; he responds to the whip but feebly, and then always falls "
   "back into his old rut. The third man is very fat, with a round, red, "
   "sentimental nose, and he plays with his eyes turned up to the sky and a "
   "look of infinite yearning. He is playing a bass part upon his cello, "
   "and so the excitement is nothing to him; no matter what happens in the "
   "treble, it is his task to saw out one long-drawn and lugubrious note "
   "after another, from four o'clock in the afternoon until nearly the same "
   "hour next morning, for his third of the total income of one dollar per "
   "hour.\n\n"
   "Before the feast has been five minutes under way, Tamoszius Kuszleika "
   "has risen in his excitement; a minute or two more and you see that he is "
   "beginning to edge over toward the tables. His nostrils are dilated and "
   "his breath comes fast--his demons are driving him. He nods and shakes "
   "his head at his companions, jerking at them with his violin, until at "
   "last the long form of the second violinist also rises up. In the end "
   "all three of them begin advancing, step by step, upon the banqueters, "
   "Valentinavyczia, the cellist, bumping along with his instrument between "
   "notes. Finally all three are gathered at the foot of the tables, and "
   "there Tamoszius mounts upon a stool.\n\n"
   "Now he is in his glory, dominating the scene. Some of the people are "
   "eating, some are laughing and talking--but you will make a great mistake "
   "if you think there is one of them who does not hear him. His notes "
   "are never true, and his fiddle buzzes on the low ones and squeaks and "
   "scratches on the high; but these things they heed no more than they heed "
   "the dirt and noise and squalor about them--it is out of this material "
   "that they have to build their lives, with it that they have to utter "
   "their souls. And this is their utterance; merry and boisterous, or "
   "mournful and wailing, or passionate and rebellious, this music is their "
   "music, music of home. It stretches out its arms to them, they have "
   "only to give themselves up. Chicago and its saloons and its slums fade "
   "away--there are green meadows and sunlit rivers, mighty forests and "
   "snow-clad hills. They behold home landscapes and childhood scenes "
   "returning; old loves and friendships begin to waken, old joys and griefs "
   "to laugh and weep. Some fall back and close their eyes, some beat upon "
   "the table. Now and then one leaps up with a cry and calls for this song "
   "or that; and then the fire leaps brighter in Tamoszius' eyes, and he "
   "flings up his fiddle and shouts to his companions, and away they go in "
   "mad career. The company takes up the choruses, and men and women cry out "
   "like all possessed; some leap to their feet and stamp upon the floor, "
   "lifting their glasses and pledging each other. Before long it occurs to "
   "some one to demand an old wedding song, which celebrates the beauty of "
   "the bride and the joys of love. In the excitement of this masterpiece "
   "Tamoszius Kuszleika begins to edge in between the tables, making his "
   "way toward the head, where sits the bride. There is not a foot of space "
   "between the chairs of the guests, and Tamoszius is so short that he "
   "pokes them with his bow whenever he reaches over for the low notes; but "
   "still he presses in, and insists relentlessly that his companions must "
   "follow. During their progress, needless to say, the sounds of the cello "
   "are pretty well extinguished; but at last the three are at the head, and "
   "Tamoszius takes his station at the right hand of the bride and begins to "
   "pour out his soul in melting strains.\n\n"
   "Little Ona is too excited to eat. Once in a while she tastes a little "
   "something, when Cousin Marija pinches her elbow and reminds her; but, "
   "for the most part, she sits gazing with the same fearful eyes of wonder. "
   "Teta Elzbieta is all in a flutter, like a hummingbird; her sisters, "
   "too, keep running up behind her, whispering, breathless. But Ona seems "
   "scarcely to hear them--the music keeps calling, and the far-off look "
   "comes back, and she sits with her hands pressed together over her heart. "
   "Then the tears begin to come into her eyes; and as she is ashamed to "
   "wipe them away, and ashamed to let them run down her cheeks, she turns "
   "and shakes her head a little, and then flushes red when she sees that "
   "Jurgis is watching her. When in the end Tamoszius Kuszleika has reached "
   "her side, and is waving his magic wand above her, Ona's cheeks are "
   "scarlet, and she looks as if she would have to get up and run away.\n\n";
