divert(-1)

###############################################################
# C LIBRARY CONSTANTS
# rebuild all libraries if changes are made
#

# ERROR

define(`__count__', 0)

define(`__EOK',         __ECOUNT__)
define(`__EACCES',      __ECOUNT__)
define(`__EBADF',       __ECOUNT__)
define(`__EBDFD',       __ECOUNT__)
define(`__EDOM',        __ECOUNT__)
define(`__EFBIG',       __ECOUNT__)
define(`__EINVAL',      __ECOUNT__)
define(`__EIO',         __ECOUNT__)
define(`__EMFILE',      __ECOUNT__)
define(`__ENFILE',      __ECOUNT__)
define(`__ENOLCK',      __ECOUNT__)
define(`__ENOMEM',      __ECOUNT__)
define(`__ENOTSUP',     __ECOUNT__)
define(`__EOVERFLOW',   __ECOUNT__)
define(`__ERANGE',      __ECOUNT__)
define(`__ESTAT',       __ECOUNT__)
define(`__EAGAIN',      __ECOUNT__)
define(`__EWOULDBLOCK', __EAGAIN)

define(`__ERROR_NEXT', 50)

# STDIO

define(`STDIO_SEEK_SET', 0)
define(`STDIO_SEEK_CUR', 1)
define(`STDIO_SEEK_END', 2)

# STDIO MESSAGES

define(`__count__', 1)

define(`STDIO_MSG_PUTC', __ECOUNT__)
define(`STDIO_MSG_WRIT', __ECOUNT__)
define(`STDIO_MSG_GETC', __ECOUNT__)
define(`STDIO_MSG_EATC', __ECOUNT__)
define(`STDIO_MSG_READ', __ECOUNT__)
define(`STDIO_MSG_SEEK', __ECOUNT__)
define(`STDIO_MSG_ICTL', __ECOUNT__)
define(`STDIO_MSG_FLSH', __ECOUNT__)
define(`STDIO_MSG_CLOS', __ECOUNT__)
      
# INPUT TERMINAL MESSAGES

define(`__count__', 15)
 
define(`ITERM_MSG_GETC',             __ECOUNT__)
define(`ITERM_MSG_REJECT',           __ECOUNT__)
define(`ITERM_MSG_INTERRUPT',        __ECOUNT__)
define(`ITERM_MSG_PUTC',             __ECOUNT__)
define(`ITERM_MSG_PRINT_CURSOR',     __ECOUNT__)
define(`ITERM_MSG_ERASE_CURSOR',     __ECOUNT__)
define(`ITERM_MSG_ERASE_CURSOR_PWD', __ECOUNT__)
define(`ITERM_MSG_BS',               __ECOUNT__)
define(`ITERM_MSG_BS_PWD',           __ECOUNT__)
define(`ITERM_MSG_READLINE_BEGIN',   __ECOUNT__)
define(`ITERM_MSG_READLINE_END',     __ECOUNT__)
define(`ITERM_MSG_READLINE_SCROLL_LIMIT', __ECOUNT__)
define(`ITERM_MSG_BELL',             __ECOUNT__)
      
define(`__MESSAGE_ITERM_NEXT__',     __ECOUNT__)
      
# OUTPUT TERMINAL MESSAGES

define(`__count__', 30)

define(`OTERM_MSG_PUTC',    __ECOUNT__)
define(`OTERM_MSG_TTY',     __ECOUNT__)
define(`OTERM_MSG_FZX_PUTC',__ECOUNT__)
define(`OTERM_MSG_PRINTC',  __ECOUNT__)
define(`OTERM_MSG_SCROLL',  __ECOUNT__)
define(`OTERM_MSG_SCROLL_LIMIT', __ECOUNT__)
define(`OTERM_MSG_CLS',     __ECOUNT__)
define(`OTERM_MSG_PAUSE',   __ECOUNT__)
define(`OTERM_MSG_BELL',    __ECOUNT__)
define(`OTERM_MSG_PSCROLL', __ECOUNT__)
define(`OTERM_MSG_FZX_GET_XOR_DRAW', __ECOUNT__)
      
define(`__MESSAGE_OTERM_NEXT__', __ECOUNT__)

# SERIAL CHARACTER I/O MESSAGES

define(`ICHAR_MSG_GETC',     ITERM_MSG_GETC)
define(`OCHAR_MSG_PUTC_BIN', OTERM_MSG_PUTC)
define(`OCHAR_MSG_PUTC',     OTERM_MSG_PRINTC)

# NEXT MESSAGE ID FOR TARGETS
      
define(`__MESSAGE_NEXT__', 45)

# THREADS

define(`mtx_plain',     0x01)
define(`mtx_recursive', 0x02)
define(`mtx_timed',     0x04)

define(`thrd_success',  0x00)
define(`thrd_error',    0x01)
define(`thrd_nomem',    0x02)
define(`thrd_busy',     0x04)
define(`thrd_timedout', 0x08)

# IOCTL

# all devices, FILE type = $00
   
define(`IOCTL_RESET', 0x0000)

# console_01_input_terminal, FILE type = $01

define(`IOCTL_ITERM_ECHO', 0xc081)
define(`IOCTL_ITERM_PASS', 0xc041)
define(`IOCTL_ITERM_LINE', 0xc021)
define(`IOCTL_ITERM_COOK', 0xc011)
define(`IOCTL_ITERM_CAPS', 0xc009)
define(`IOCTL_ITERM_CRLF', 0xc101)
define(`IOCTL_ITERM_CURS', 0xc201)
   
define(`IOCTL_ITERM_TIE',         0x0201)
define(`IOCTL_ITERM_GET_EDITBUF', 0x0381)
define(`IOCTL_ITERM_SET_EDITBUF', 0x0301)

# console_01_output_terminal, FILE type = $02

define(`IOCTL_OTERM_PAGE',   0xc082)
define(`IOCTL_OTERM_PAUSE',  0xc042)
define(`IOCTL_OTERM_COOK',   0xc022)
define(`IOCTL_OTERM_CRLF',   0xc012)
define(`IOCTL_OTERM_CLEAR',  0xe002)
define(`IOCTL_OTERM_SIGNAL', 0xc202)
define(`IOCTL_OTERM_BELL',   0xc102)

define(`IOCTL_OTERM_CLS',              0x0102)
define(`IOCTL_OTERM_RESET_SCROLL',     0x0202)
define(`IOCTL_OTERM_GET_WINDOW_COORD', 0x0382)
define(`IOCTL_OTERM_SET_WINDOW_COORD', 0x0302)
define(`IOCTL_OTERM_GET_WINDOW_RECT',  0x0482)
define(`IOCTL_OTERM_SET_WINDOW_RECT',  0x0402)
define(`IOCTL_OTERM_GET_CURSOR_COORD', 0x0582)
define(`IOCTL_OTERM_SET_CURSOR_COORD', 0x0502)
define(`IOCTL_OTERM_GET_OTERM',        0x0602)
define(`IOCTL_OTERM_SCROLL',           0x0702)
define(`IOCTL_OTERM_FONT',             0x0802)
define(`IOCTL_OTERM_SCROLL_LIMIT',     0x0902)

define(`IOCTL_OTERM_FZX_GET_PAPER_COORD', 0x0a82)
define(`IOCTL_OTERM_FZX_SET_PAPER_COORD', 0x0a02)
define(`IOCTL_OTERM_FZX_GET_PAPER_RECT',  0x0b82)
define(`IOCTL_OTERM_FZX_SET_PAPER_RECT',  0x0b02)
define(`IOCTL_OTERM_FZX_LEFT_MARGIN',     0x0c02)
define(`IOCTL_OTERM_FZX_LINE_SPACING',    0x0d02)
define(`IOCTL_OTERM_FZX_SPACE_EXPAND',    0x0e02)
define(`IOCTL_OTERM_FZX_GET_FZX_STATE',   0x0f82)
define(`IOCTL_OTERM_FZX_SET_FZX_STATE',   0x0f02)

# character_00_input, FILE type = $03

define(`IOCTL_ICHAR_CRLF', 0xc103)
   
# character_00_output, FILE type = $04
   
define(`IOCTL_OCHAR_CRLF', 0xc014)

#
# END OF USER CONFIGURATION
###############################################################

divert(0)

dnl#
dnl# COMPILE TIME CONFIG EXPORT FOR ASSEMBLY LANGUAGE
dnl#

ifdef(`CFG_ASM_PUB',
`
PUBLIC `__EOK'
PUBLIC `__EACCES'
PUBLIC `__EBADF'
PUBLIC `__EBDFD'
PUBLIC `__EDOM'
PUBLIC `__EFBIG'
PUBLIC `__EINVAL'
PUBLIC `__EIO'
PUBLIC `__EMFILE'
PUBLIC `__ENFILE'
PUBLIC `__ENOLCK'
PUBLIC `__ENOMEM'
PUBLIC `__ENOTSUP'
PUBLIC `__EOVERFLOW'
PUBLIC `__ERANGE'
PUBLIC `__ESTAT'
PUBLIC `__EAGAIN'
PUBLIC `__EWOULDBLOCK'

PUBLIC `__ERROR_NEXT'

PUBLIC `STDIO_SEEK_SET'
PUBLIC `STDIO_SEEK_CUR'
PUBLIC `STDIO_SEEK_END'

PUBLIC `STDIO_MSG_PUTC'
PUBLIC `STDIO_MSG_WRIT'
PUBLIC `STDIO_MSG_GETC'
PUBLIC `STDIO_MSG_EATC'
PUBLIC `STDIO_MSG_READ'
PUBLIC `STDIO_MSG_SEEK'
PUBLIC `STDIO_MSG_ICTL'
PUBLIC `STDIO_MSG_FLSH'
PUBLIC `STDIO_MSG_CLOS'

PUBLIC `ITERM_MSG_GETC'
PUBLIC `ITERM_MSG_REJECT'
PUBLIC `ITERM_MSG_INTERRUPT'
PUBLIC `ITERM_MSG_PUTC'
PUBLIC `ITERM_MSG_PRINT_CURSOR'
PUBLIC `ITERM_MSG_ERASE_CURSOR'
PUBLIC `ITERM_MSG_ERASE_CURSOR_PWD'
PUBLIC `ITERM_MSG_BS'
PUBLIC `ITERM_MSG_BS_PWD'
PUBLIC `ITERM_MSG_READLINE_BEGIN'
PUBLIC `ITERM_MSG_READLINE_END'
PUBLIC `ITERM_MSG_READLINE_SCROLL_LIMIT'
PUBLIC `ITERM_MSG_BELL'
      
PUBLIC `__MESSAGE_ITERM_NEXT__'

PUBLIC `OTERM_MSG_PUTC'
PUBLIC `OTERM_MSG_TTY'
PUBLIC `OTERM_MSG_FZX_PUTC'
PUBLIC `OTERM_MSG_PRINTC'
PUBLIC `OTERM_MSG_SCROLL'
PUBLIC `OTERM_MSG_SCROLL_LIMIT'
PUBLIC `OTERM_MSG_CLS'
PUBLIC `OTERM_MSG_PAUSE'
PUBLIC `OTERM_MSG_BELL'
PUBLIC `OTERM_MSG_PSCROLL'
PUBLIC `OTERM_MSG_FZX_GET_XOR_DRAW'
      
PUBLIC `__MESSAGE_OTERM_NEXT__'

PUBLIC `ICHAR_MSG_GETC'
PUBLIC `OCHAR_MSG_PUTC_BIN'
PUBLIC `OCHAR_MSG_PUTC'
  
PUBLIC `__MESSAGE_NEXT__'

PUBLIC `mtx_plain'
PUBLIC `mtx_recursive'
PUBLIC `mtx_timed'

PUBLIC `thrd_success'
PUBLIC `thrd_error'
PUBLIC `thrd_nomem'
PUBLIC `thrd_busy'
PUBLIC `thrd_timedout'

PUBLIC `IOCTL_RESET'

PUBLIC `IOCTL_ITERM_ECHO'
PUBLIC `IOCTL_ITERM_PASS'
PUBLIC `IOCTL_ITERM_LINE'
PUBLIC `IOCTL_ITERM_COOK'
PUBLIC `IOCTL_ITERM_CAPS'
PUBLIC `IOCTL_ITERM_CRLF'
PUBLIC `IOCTL_ITERM_CURS'
   
PUBLIC `IOCTL_ITERM_TIE'
PUBLIC `IOCTL_ITERM_GET_EDITBUF'
PUBLIC `IOCTL_ITERM_SET_EDITBUF'

PUBLIC `IOCTL_OTERM_PAGE'
PUBLIC `IOCTL_OTERM_PAUSE'
PUBLIC `IOCTL_OTERM_COOK'
PUBLIC `IOCTL_OTERM_CRLF'
PUBLIC `IOCTL_OTERM_CLEAR'
PUBLIC `IOCTL_OTERM_SIGNAL'
PUBLIC `IOCTL_OTERM_BELL'

PUBLIC `IOCTL_OTERM_CLS'
PUBLIC `IOCTL_OTERM_RESET_SCROLL'
PUBLIC `IOCTL_OTERM_GET_WINDOW_COORD'
PUBLIC `IOCTL_OTERM_SET_WINDOW_COORD'
PUBLIC `IOCTL_OTERM_GET_WINDOW_RECT'
PUBLIC `IOCTL_OTERM_SET_WINDOW_RECT'
PUBLIC `IOCTL_OTERM_GET_CURSOR_COORD'
PUBLIC `IOCTL_OTERM_SET_CURSOR_COORD'
PUBLIC `IOCTL_OTERM_GET_OTERM'
PUBLIC `IOCTL_OTERM_SCROLL'
PUBLIC `IOCTL_OTERM_FONT'
PUBLIC `IOCTL_OTERM_SCROLL_LIMIT'

PUBLIC `IOCTL_OTERM_FZX_GET_PAPER_COORD'
PUBLIC `IOCTL_OTERM_FZX_SET_PAPER_COORD'
PUBLIC `IOCTL_OTERM_FZX_GET_PAPER_RECT'
PUBLIC `IOCTL_OTERM_FZX_SET_PAPER_RECT'
PUBLIC `IOCTL_OTERM_FZX_LEFT_MARGIN'
PUBLIC `IOCTL_OTERM_FZX_LINE_SPACING'
PUBLIC `IOCTL_OTERM_FZX_SPACE_EXPAND'
PUBLIC `IOCTL_OTERM_FZX_GET_FZX_STATE'
PUBLIC `IOCTL_OTERM_FZX_SET_FZX_STATE'

PUBLIC `IOCTL_ICHAR_CRLF'
   
PUBLIC `IOCTL_OCHAR_CRLF'
')

dnl#
dnl# LIBRARY BUILD TIME CONFIG FOR ASSEMBLY LANGUAGE
dnl#

ifdef(`CFG_ASM_DEF',
`
defc `__EOK' = __EOK
defc `__EACCES' = __EACCES
defc `__EBADF' = __EBADF
defc `__EBDFD' = __EBDFD
defc `__EDOM' = __EDOM
defc `__EFBIG' = __EFBIG
defc `__EINVAL' = __EINVAL
defc `__EIO' = __EIO
defc `__EMFILE' = __EMFILE
defc `__ENFILE' = __ENFILE
defc `__ENOLCK' = __ENOLCK
defc `__ENOMEM' = __ENOMEM
defc `__ENOTSUP' = __ENOTSUP
defc `__EOVERFLOW' = __EOVERFLOW
defc `__ERANGE' = __ERANGE
defc `__ESTAT' = __ESTAT
defc `__EAGAIN' = __EAGAIN
defc `__EWOULDBLOCK' = __EWOULDBLOCK

defc `__ERROR_NEXT' = __ERROR_NEXT

defc `STDIO_SEEK_SET' = STDIO_SEEK_SET
defc `STDIO_SEEK_CUR' = STDIO_SEEK_CUR
defc `STDIO_SEEK_END' = STDIO_SEEK_END

defc `STDIO_MSG_PUTC' = STDIO_MSG_PUTC
defc `STDIO_MSG_WRIT' = STDIO_MSG_WRIT
defc `STDIO_MSG_GETC' = STDIO_MSG_GETC
defc `STDIO_MSG_EATC' = STDIO_MSG_EATC
defc `STDIO_MSG_READ' = STDIO_MSG_READ
defc `STDIO_MSG_SEEK' = STDIO_MSG_SEEK
defc `STDIO_MSG_ICTL' = STDIO_MSG_ICTL
defc `STDIO_MSG_FLSH' = STDIO_MSG_FLSH
defc `STDIO_MSG_CLOS' = STDIO_MSG_CLOS

defc `ITERM_MSG_GETC' = ITERM_MSG_GETC
defc `ITERM_MSG_REJECT' = ITERM_MSG_REJECT
defc `ITERM_MSG_INTERRUPT' = ITERM_MSG_INTERRUPT
defc `ITERM_MSG_PUTC' = ITERM_MSG_PUTC
defc `ITERM_MSG_PRINT_CURSOR' = ITERM_MSG_PRINT_CURSOR
defc `ITERM_MSG_ERASE_CURSOR' = ITERM_MSG_ERASE_CURSOR
defc `ITERM_MSG_ERASE_CURSOR_PWD' = ITERM_MSG_ERASE_CURSOR_PWD
defc `ITERM_MSG_BS' = ITERM_MSG_BS
defc `ITERM_MSG_BS_PWD' = ITERM_MSG_BS_PWD
defc `ITERM_MSG_READLINE_BEGIN' = ITERM_MSG_READLINE_BEGIN
defc `ITERM_MSG_READLINE_END' = ITERM_MSG_READLINE_END
defc `ITERM_MSG_READLINE_SCROLL_LIMIT' = ITERM_MSG_READLINE_SCROLL_LIMIT
defc `ITERM_MSG_BELL' = ITERM_MSG_BELL
      
defc `__MESSAGE_ITERM_NEXT__' = __MESSAGE_ITERM_NEXT__

defc `OTERM_MSG_PUTC' = OTERM_MSG_PUTC
defc `OTERM_MSG_TTY' = OTERM_MSG_TTY
defc `OTERM_MSG_FZX_PUTC' = OTERM_MSG_FZX_PUTC
defc `OTERM_MSG_PRINTC' = OTERM_MSG_PRINTC
defc `OTERM_MSG_SCROLL' = OTERM_MSG_SCROLL
defc `OTERM_MSG_SCROLL_LIMIT' = OTERM_MSG_SCROLL_LIMIT
defc `OTERM_MSG_CLS' = OTERM_MSG_CLS
defc `OTERM_MSG_PAUSE' = OTERM_MSG_PAUSE
defc `OTERM_MSG_BELL' = OTERM_MSG_BELL
defc `OTERM_MSG_PSCROLL' = OTERM_MSG_PSCROLL
defc `OTERM_MSG_FZX_GET_XOR_DRAW' = OTERM_MSG_FZX_GET_XOR_DRAW
      
defc `__MESSAGE_OTERM_NEXT__' = __MESSAGE_OTERM_NEXT__

defc `ICHAR_MSG_GETC' = ICHAR_MSG_GETC
defc `OCHAR_MSG_PUTC_BIN' = OCHAR_MSG_PUTC_BIN
defc `OCHAR_MSG_PUTC' = OCHAR_MSG_PUTC
  
defc `__MESSAGE_NEXT__' = __MESSAGE_NEXT__

defc `mtx_plain' = mtx_plain
defc `mtx_recursive' = mtx_recursive
defc `mtx_timed' = mtx_timed

defc `thrd_success' = thrd_success
defc `thrd_error' = thrd_error
defc `thrd_nomem' = thrd_nomem
defc `thrd_busy' = thrd_busy
defc `thrd_timedout' = thrd_timedout

defc `IOCTL_RESET' = IOCTL_RESET

defc `IOCTL_ITERM_ECHO' = IOCTL_ITERM_ECHO
defc `IOCTL_ITERM_PASS' = IOCTL_ITERM_PASS
defc `IOCTL_ITERM_LINE' = IOCTL_ITERM_LINE
defc `IOCTL_ITERM_COOK' = IOCTL_ITERM_COOK
defc `IOCTL_ITERM_CAPS' = IOCTL_ITERM_CAPS
defc `IOCTL_ITERM_CRLF' = IOCTL_ITERM_CRLF
defc `IOCTL_ITERM_CURS' = IOCTL_ITERM_CURS
   
defc `IOCTL_ITERM_TIE' = IOCTL_ITERM_TIE
defc `IOCTL_ITERM_GET_EDITBUF' = IOCTL_ITERM_GET_EDITBUF
defc `IOCTL_ITERM_SET_EDITBUF' = IOCTL_ITERM_SET_EDITBUF

defc `IOCTL_OTERM_PAGE' = IOCTL_OTERM_PAGE
defc `IOCTL_OTERM_PAUSE' = IOCTL_OTERM_PAUSE
defc `IOCTL_OTERM_COOK' = IOCTL_OTERM_COOK
defc `IOCTL_OTERM_CRLF' = IOCTL_OTERM_CRLF
defc `IOCTL_OTERM_CLEAR' = IOCTL_OTERM_CLEAR
defc `IOCTL_OTERM_SIGNAL' = IOCTL_OTERM_SIGNAL
defc `IOCTL_OTERM_BELL' = IOCTL_OTERM_BELL

defc `IOCTL_OTERM_CLS' = IOCTL_OTERM_CLS
defc `IOCTL_OTERM_RESET_SCROLL' = IOCTL_OTERM_RESET_SCROLL
defc `IOCTL_OTERM_GET_WINDOW_COORD' = IOCTL_OTERM_GET_WINDOW_COORD
defc `IOCTL_OTERM_SET_WINDOW_COORD' = IOCTL_OTERM_SET_WINDOW_COORD
defc `IOCTL_OTERM_GET_WINDOW_RECT' = IOCTL_OTERM_GET_WINDOW_RECT
defc `IOCTL_OTERM_SET_WINDOW_RECT' = IOCTL_OTERM_SET_WINDOW_RECT
defc `IOCTL_OTERM_GET_CURSOR_COORD' = IOCTL_OTERM_GET_CURSOR_COORD
defc `IOCTL_OTERM_SET_CURSOR_COORD' = IOCTL_OTERM_SET_CURSOR_COORD
defc `IOCTL_OTERM_GET_OTERM' = IOCTL_OTERM_GET_OTERM
defc `IOCTL_OTERM_SCROLL' = IOCTL_OTERM_SCROLL
defc `IOCTL_OTERM_FONT' = IOCTL_OTERM_FONT
defc `IOCTL_OTERM_SCROLL_LIMIT' = IOCTL_OTERM_SCROLL_LIMIT

defc `IOCTL_OTERM_FZX_GET_PAPER_COORD' = IOCTL_OTERM_FZX_GET_PAPER_COORD
defc `IOCTL_OTERM_FZX_SET_PAPER_COORD' = IOCTL_OTERM_FZX_SET_PAPER_COORD
defc `IOCTL_OTERM_FZX_GET_PAPER_RECT' = IOCTL_OTERM_FZX_GET_PAPER_RECT
defc `IOCTL_OTERM_FZX_SET_PAPER_RECT' = IOCTL_OTERM_FZX_SET_PAPER_RECT
defc `IOCTL_OTERM_FZX_LEFT_MARGIN' = IOCTL_OTERM_FZX_LEFT_MARGIN
defc `IOCTL_OTERM_FZX_LINE_SPACING' = IOCTL_OTERM_FZX_LINE_SPACING
defc `IOCTL_OTERM_FZX_SPACE_EXPAND' = IOCTL_OTERM_FZX_SPACE_EXPAND
defc `IOCTL_OTERM_FZX_GET_FZX_STATE' = IOCTL_OTERM_FZX_GET_FZX_STATE
defc `IOCTL_OTERM_FZX_SET_FZX_STATE' = IOCTL_OTERM_FZX_SET_FZX_STATE

defc `IOCTL_ICHAR_CRLF' = IOCTL_ICHAR_CRLF
   
defc `IOCTL_OCHAR_CRLF' = IOCTL_OCHAR_CRLF
')

dnl#
dnl# COMPILE TIME CONFIG EXPORT FOR C
dnl#

ifdef(`CFG_C_DEF',
`
`#define' `__EOK'  __EOK
`#define' `__EACCES'  __EACCES
`#define' `__EBADF'  __EBADF
`#define' `__EBDFD'  __EBDFD
`#define' `__EDOM'  __EDOM
`#define' `__EFBIG'  __EFBIG
`#define' `__EINVAL'  __EINVAL
`#define' `__EIO'  __EIO
`#define' `__EMFILE'  __EMFILE
`#define' `__ENFILE'  __ENFILE
`#define' `__ENOLCK'  __ENOLCK
`#define' `__ENOMEM'  __ENOMEM
`#define' `__ENOTSUP'  __ENOTSUP
`#define' `__EOVERFLOW'  __EOVERFLOW
`#define' `__ERANGE'  __ERANGE
`#define' `__ESTAT'  __ESTAT
`#define' `__EAGAIN'  __EAGAIN
`#define' `__EWOULDBLOCK'  __EWOULDBLOCK

`#define' `__ERROR_NEXT'  __ERROR_NEXT

`#define' `STDIO_SEEK_SET'  STDIO_SEEK_SET
`#define' `STDIO_SEEK_CUR'  STDIO_SEEK_CUR
`#define' `STDIO_SEEK_END'  STDIO_SEEK_END

`#define' `STDIO_MSG_PUTC'  STDIO_MSG_PUTC
`#define' `STDIO_MSG_WRIT'  STDIO_MSG_WRIT
`#define' `STDIO_MSG_GETC'  STDIO_MSG_GETC
`#define' `STDIO_MSG_EATC'  STDIO_MSG_EATC
`#define' `STDIO_MSG_READ'  STDIO_MSG_READ
`#define' `STDIO_MSG_SEEK'  STDIO_MSG_SEEK
`#define' `STDIO_MSG_ICTL'  STDIO_MSG_ICTL
`#define' `STDIO_MSG_FLSH'  STDIO_MSG_FLSH
`#define' `STDIO_MSG_CLOS'  STDIO_MSG_CLOS

`#define' `ITERM_MSG_GETC'  ITERM_MSG_GETC
`#define' `ITERM_MSG_REJECT'  ITERM_MSG_REJECT
`#define' `ITERM_MSG_INTERRUPT'  ITERM_MSG_INTERRUPT
`#define' `ITERM_MSG_PUTC'  ITERM_MSG_PUTC
`#define' `ITERM_MSG_PRINT_CURSOR'  ITERM_MSG_PRINT_CURSOR
`#define' `ITERM_MSG_ERASE_CURSOR'  ITERM_MSG_ERASE_CURSOR
`#define' `ITERM_MSG_ERASE_CURSOR_PWD'  ITERM_MSG_ERASE_CURSOR_PWD
`#define' `ITERM_MSG_BS'  ITERM_MSG_BS
`#define' `ITERM_MSG_BS_PWD'  ITERM_MSG_BS_PWD
`#define' `ITERM_MSG_READLINE_BEGIN'  ITERM_MSG_READLINE_BEGIN
`#define' `ITERM_MSG_READLINE_END'  ITERM_MSG_READLINE_END
`#define' `ITERM_MSG_READLINE_SCROLL_LIMIT'  ITERM_MSG_READLINE_SCROLL_LIMIT
`#define' `ITERM_MSG_BELL'  ITERM_MSG_BELL
      
`#define' `__MESSAGE_ITERM_NEXT__'  __MESSAGE_ITERM_NEXT__

`#define' `OTERM_MSG_PUTC'  OTERM_MSG_PUTC
`#define' `OTERM_MSG_TTY'  OTERM_MSG_TTY
`#define' `OTERM_MSG_FZX_PUTC'  OTERM_MSG_FZX_PUTC
`#define' `OTERM_MSG_PRINTC'  OTERM_MSG_PRINTC
`#define' `OTERM_MSG_SCROLL'  OTERM_MSG_SCROLL
`#define' `OTERM_MSG_SCROLL_LIMIT'  OTERM_MSG_SCROLL_LIMIT
`#define' `OTERM_MSG_CLS'  OTERM_MSG_CLS
`#define' `OTERM_MSG_PAUSE'  OTERM_MSG_PAUSE
`#define' `OTERM_MSG_BELL'  OTERM_MSG_BELL
`#define' `OTERM_MSG_PSCROLL'  OTERM_MSG_PSCROLL
`#define' `OTERM_MSG_FZX_GET_XOR_DRAW'  OTERM_MSG_FZX_GET_XOR_DRAW
      
`#define' `__MESSAGE_OTERM_NEXT__'  __MESSAGE_OTERM_NEXT__

`#define' `ICHAR_MSG_GETC'  ICHAR_MSG_GETC
`#define' `OCHAR_MSG_PUTC_BIN'  OCHAR_MSG_PUTC_BIN
`#define' `OCHAR_MSG_PUTC'  OCHAR_MSG_PUTC
  
`#define' `__MESSAGE_NEXT__'  __MESSAGE_NEXT__

`#define' `mtx_plain'  mtx_plain
`#define' `mtx_recursive'  mtx_recursive
`#define' `mtx_timed'  mtx_timed

`#define' `thrd_success'  thrd_success
`#define' `thrd_error'  thrd_error
`#define' `thrd_nomem'  thrd_nomem
`#define' `thrd_busy'  thrd_busy
`#define' `thrd_timedout'  thrd_timedout

`#define' `IOCTL_RESET'  IOCTL_RESET

`#define' `IOCTL_ITERM_ECHO'  IOCTL_ITERM_ECHO
`#define' `IOCTL_ITERM_PASS'  IOCTL_ITERM_PASS
`#define' `IOCTL_ITERM_LINE'  IOCTL_ITERM_LINE
`#define' `IOCTL_ITERM_COOK'  IOCTL_ITERM_COOK
`#define' `IOCTL_ITERM_CAPS'  IOCTL_ITERM_CAPS
`#define' `IOCTL_ITERM_CRLF'  IOCTL_ITERM_CRLF
`#define' `IOCTL_ITERM_CURS'  IOCTL_ITERM_CURS
   
`#define' `IOCTL_ITERM_TIE'  IOCTL_ITERM_TIE
`#define' `IOCTL_ITERM_GET_EDITBUF'  IOCTL_ITERM_GET_EDITBUF
`#define' `IOCTL_ITERM_SET_EDITBUF'  IOCTL_ITERM_SET_EDITBUF

`#define' `IOCTL_OTERM_PAGE'  IOCTL_OTERM_PAGE
`#define' `IOCTL_OTERM_PAUSE'  IOCTL_OTERM_PAUSE
`#define' `IOCTL_OTERM_COOK'  IOCTL_OTERM_COOK
`#define' `IOCTL_OTERM_CRLF'  IOCTL_OTERM_CRLF
`#define' `IOCTL_OTERM_CLEAR'  IOCTL_OTERM_CLEAR
`#define' `IOCTL_OTERM_SIGNAL'  IOCTL_OTERM_SIGNAL
`#define' `IOCTL_OTERM_BELL'  IOCTL_OTERM_BELL

`#define' `IOCTL_OTERM_CLS'  IOCTL_OTERM_CLS
`#define' `IOCTL_OTERM_RESET_SCROLL'  IOCTL_OTERM_RESET_SCROLL
`#define' `IOCTL_OTERM_GET_WINDOW_COORD'  IOCTL_OTERM_GET_WINDOW_COORD
`#define' `IOCTL_OTERM_SET_WINDOW_COORD'  IOCTL_OTERM_SET_WINDOW_COORD
`#define' `IOCTL_OTERM_GET_WINDOW_RECT'  IOCTL_OTERM_GET_WINDOW_RECT
`#define' `IOCTL_OTERM_SET_WINDOW_RECT'  IOCTL_OTERM_SET_WINDOW_RECT
`#define' `IOCTL_OTERM_GET_CURSOR_COORD'  IOCTL_OTERM_GET_CURSOR_COORD
`#define' `IOCTL_OTERM_SET_CURSOR_COORD'  IOCTL_OTERM_SET_CURSOR_COORD
`#define' `IOCTL_OTERM_GET_OTERM'  IOCTL_OTERM_GET_OTERM
`#define' `IOCTL_OTERM_SCROLL'  IOCTL_OTERM_SCROLL
`#define' `IOCTL_OTERM_FONT'  IOCTL_OTERM_FONT
`#define' `IOCTL_OTERM_SCROLL_LIMIT'  IOCTL_OTERM_SCROLL_LIMIT

`#define' `IOCTL_OTERM_FZX_GET_PAPER_COORD'  IOCTL_OTERM_FZX_GET_PAPER_COORD
`#define' `IOCTL_OTERM_FZX_SET_PAPER_COORD'  IOCTL_OTERM_FZX_SET_PAPER_COORD
`#define' `IOCTL_OTERM_FZX_GET_PAPER_RECT'  IOCTL_OTERM_FZX_GET_PAPER_RECT
`#define' `IOCTL_OTERM_FZX_SET_PAPER_RECT'  IOCTL_OTERM_FZX_SET_PAPER_RECT
`#define' `IOCTL_OTERM_FZX_LEFT_MARGIN'  IOCTL_OTERM_FZX_LEFT_MARGIN
`#define' `IOCTL_OTERM_FZX_LINE_SPACING'  IOCTL_OTERM_FZX_LINE_SPACING
`#define' `IOCTL_OTERM_FZX_SPACE_EXPAND'  IOCTL_OTERM_FZX_SPACE_EXPAND
`#define' `IOCTL_OTERM_FZX_GET_FZX_STATE'  IOCTL_OTERM_FZX_GET_FZX_STATE
`#define' `IOCTL_OTERM_FZX_SET_FZX_STATE'  IOCTL_OTERM_FZX_SET_FZX_STATE

`#define' `IOCTL_ICHAR_CRLF'  IOCTL_ICHAR_CRLF
   
`#define' `IOCTL_OCHAR_CRLF'  IOCTL_OCHAR_CRLF
')
